;+
;
; @param VV 
; 3D opa velocity field
;
; @param SIG
; 3D opa density field (sig2 or 4, or gamma 
;
; @param S_S 
; sigma_values
;
; @keyword MASK 
; vglomsk
;
; @keyword ORCA
; = 2, 5....
;
; @uses
; <pro>common</pro>
;
; @version
; $Id$
;
;-
FUNCTION msfs, vv, sig, s_s $
         , MASK=mask $
         , ORCA=orca
;
  compile_opt idl2, strictarrsubs
;
@common
;-------------------------
; density at V point & vmask
;-------------------------
      density = vmask()*(sig+shift(sig, 0, -1, 0))/2
;      density = vmask()*sig
      vvmask = vmask()
      density[*,jpj-1,*]=0.e0        ; set to zero the northern j-line
      density=density*vmask()
;-------------------------
; partial step: e3v 3d
;-------------------------
      ioMESH = iodir+'meshes'
      fich_msh = 'mesh_mask_NDV1.nc'
      pe3v = read_ncdf('e3v_ps',0,/timestep,iodir=ioMESH,/nostruct,/tout,filename=fich_msh)
      vvf = vv * reform(e1v[*]#replicate(1,jpk),jpi,jpj,jpk) * pe3v *vmask()
;-------------------------
; gibraltar cross land adv: 5 Sv
; N/S profile:   level  0-13    0.8 Sv
;                level 14-19    0.7 Sv
;                level 20       2.5 Sv
;                level 21       1.0 Sv
      vvf[167,100, 0:13] = vvf[167,100, 0:13]+0.8e+6/14.*vvmask[167,100, 0:13]
      vvf[167,100,14:19] = vvf[167,100,14:19]+0.7e+6/6. *vvmask[167,100,14:19]
      vvf[167,100, 20  ] = vvf[167,100, 20  ]+2.5e+6    *vvmask[167,100, 20  ]
      vvf[167,100, 21  ] = vvf[167,100, 21  ]+0.8e+6/14.*vvmask[167,100, 21  ]
;-------------------------
if keyword_set(mask) then begin                 &$
      print, 'subdomain: use of mask argument'  &$
     if (size(mask))[0] eq 2 then vvf=vvf*reform(mask[*]#replicate(1,jpk),jpi,jpj,jpk) &$
endif                                           &$
;-------------------------
; crude summation
;-------------------------
      n_s = n_elements(s_s)		; number of density levels
      x1_bin = fltarr(jpj, n_s)	; output array (transport function of density)
	  x1_bin[*,*] = 0.e0
      FOR is = n_s-1,0,-1 DO begin               &$
         dmsk= density GT s_s[is]                &$
      x1_bin[*,is] = total( total(vvf*dmsk,1),2)  &$
      ENDFOR                                     &$
      msfs=x1_bin *1.e-6
;------------------------
return, msfs
end
